#!/usr/bin/env python2
from __future__ import print_function

"""fcgi.py: FastCGI eavesdropper"""
__version__   = "1.0"
__author__    = "ed <irc.rizon.net>"
__license__   = "BSD"
__copyright__ = 2015

import binascii
from time import sleep
import sys
import re
import os

# strace -xxfs65535 -p6200 2>&1 | stdbuf -oL grep '\\x0f\\x0f' | stdbuf -oL sed 's/^[^"]*"//;s/"[^"]*$//;s/\x//g' | while read x;do echo "$x" | stdbuf -oL xxd -r -p | hexdump -C; done

### start transmission
# poll([{fd=4, events=POLLIN}], 1, 5000)  = 1 ([{fd=4, revents=POLLIN}])
# poll([{fd=3, events=POLLIN}], 1, 5000)  = 1 ([{fd=3, revents=POLLIN}])

### static header 1
# read(4, "\x01\x01\x00\x01\x00\x08\x00\x00", 8) = 8
# read(3, "\x01\x01\x00\x01\x00\x08\x00\x00", 8) = 8

### static header 2
# read(4, "\x00\x01\x00\x00\x00\x00\x00\x00", 8) = 8
# read(3, "\x00\x01\x00\x00\x00\x00\x00\x00", 8) = 8

### header length            vv  vv
# read(4, "\x01\x04\x00\x01\x03\xe9\x07\x00", 8) = 8   1008 = 3e9+7 (e)
# read(3, "\x01\x04\x00\x01\x02\xf8\x00\x00", 8) = 8    760 = 2f8   (r)
# read(3, "\x01\x04\x00\x01\x03\x61\x00\x00", 8) = 8    865 = 361   (n)
# read(3, "\x01\x04\x00\x01\x02\xa1\x00\x00", 8) = 8    673 = 2a1   (n,GET)
# read(3, "\x01\x04\x00\x01\x03\x27\x00\x00", 8) = 8    807 = 327   (n,MP1)

### incoming header
# read(4, "\x0f\x1a\x53\x43\x52\x49\x50\x54\x5f...", n) = n

### end header
# read(4, "\x01\x04\x00\x01\x00\x00\x00\x00", 8) = 8
# read(3, "\x01\x04\x00\x01\x00\x00\x00\x00", 8) = 8
# read(3, "\x01\x04\x00\x01\x00\x00\x00\x00", 8) = 8

### begin x-www-form
# read(4, "\x01\x05\x00\x01\x00\x0f\x01\x00", 8) = 8    e
# read(3, "\x01\x05\x00\x01\x00\x29\x00\x00", 8) = 8    n
# read(3, "\x01\x05\x00\x01\x02\x6d\x00\x00", 8) = 8    n mp

### x-www-form
# read(4, "\x61\x62\x63...\x64", 15) = 15   e
# read(3, "\x66\x69\x75...\x74", 41) = 41   n
# read(4, "\x3c\x3f\x70...\x0d\x0a", 4096) = 1410
# read(3, "\x66\x69\x75...\x65\x72\x79", 621) = 621    n mp



# [ 1=fd ]  initializes a transaction, sets FD to listen to
rxInit = re.compile('^poll\(\[{fd=([0-9]*), events=POLLIN}\], 1, 5000\)  = 1 \(\[{fd=[0-9]*, revents=POLLIN}\]\)$')

# [ 1=fd ]  static message
rxSync1 = re.compile('^read\(([0-9]*), ".x01.x01.x00.x01.x00.x08.x00.x00", 8\) = 8$')

# [ 1=fd ]  static message
rxSync2 = re.compile('^read\(([0-9]*), ".x00.x01.x00.x00.x00.x00.x00.x00", 8\) = 8$')

# [ 1=fd, 2=message, 3=len, 4=len ]  incoming header or body
rxMessage = re.compile('^read\(([0-9]*), "([^"]*)", ([0-9]*)\) = ([0-9]*)$')

# [ 1=fd ]  http header length (dontcare)
rxHeaderStart = re.compile('^read\(([0-9]*), ".x01.x04.x00.x01.x...x...x...x..", 8\) = 8$')

# [ 1=fd ]  end http header (rxSync3 with len=0)
rxHeaderEnd = re.compile('^read\(([0-9]*), ".x01.x04.x00.x01.x00.x00.x00.x00", 8\) = 8$')

# [ 1=fd ]  http body length (dontcare)
rxBodyStart = re.compile('^read\(([0-9]*), ".x01.x05.x00.x01.x...x...x...x..", 8\) = 8$')

# [ 1=fd, 2=body ]  server reply
# txBody = re.compile('^write\(([0-9]*), ".x01.x06.x00.x01.x06.xac.x04.x00(.*)(?:.x01.x03.x00.x01.x00.x08)(?:.x00)*", ([0-9]*)\) = ([0-9]*)$')
# txBody = re.compile('^write\(([0-9]*), ".x01.x06.x00.x01.x01.x45.x03.x00(.*)(?:.x00.x00.x00.x01.x03.x00.x01.x00.x08)(?:.x00)*", ([0-9]*)\) = ([0-9]*)$')
txBody = re.compile('^write\(([0-9]*), ".x01.x06.x00.x01(.x...x...x...x...x.*)", ([0-9]*)\) = ([0-9]*)$')

known = [
	'SERVER_SOFTWARE',
	'SERVER_NAME',
	'GATEWAY_INTERFACE',
	'SERVER_PORT',
	'SERVER_ADDR',
	'REMOTE_PORT',
	'REMOTE_ADDR',
	'SCRIPT_NAME',
	'PATH_INFO',
	'SCRIPT_FILENAME',
	'DOCUMENT_ROOT',
	'REDIRECT_STATUS',
	'SERVER_PROTOCOL'
]

def tailf(filename):
	first_call = True
	while True:
		try:
			with open(filename, 'r') as input:
				if not first_call:
					input.seek(0, 2)
				first_call = False
				latest_data = input.read()
				while True:
					if '\n' not in latest_data:
						latest_data += input.read()
						if '\n' not in latest_data:
							yield ''
							sleep(0.5)
							if not os.path.isfile(filename):
								break
							continue
					latest_lines = latest_data.split('\n')
					if latest_data[-1] != '\n':
						latest_data = latest_lines[-1]
					else:
						latest_data = input.read()
					for line in latest_lines[:-1]:
						yield line + '\n'
		except IOError:
			yield ''


#print("Attach strace to an FCGI Server (not the HTTPd) and feed STDERR into this program.")
#print("Example:")
#print("  strace -xxfs65535 -p$(pidof -s php-cgi) 2>&1 | stdbuf -oL tee fcgilog | fcgi.py")
print()
if len(sys.argv) < 2:
	print("Point this program to an FCGI-Server strace logfile (not HTTPd)")
	print("Terminal-1)  strace -xxfs65535 -p$(pidof -s php-cgi) 2>fcgilog")
	print("Terminal-2)  {} fcgilog".format(sys.argv[0]))
	exit(1)

fd = 0
state = 0
#for line in sys.stdin:
for line in tailf(sys.argv[1]):
	if line == '':
		continue
	
	# TODO:
	#   Figure out what assumptions are safe, then rewrite this mess
	#print('r{} -- {}'.format(state, line))
	
	rs = rxInit.match(line)
	if rs:
		if state != 0:
			print('ASSERTION FAILURE: {} != s0 (rxInit)'.format(state))
		fd = rs.group(1)
		state = 1
		continue
	
	rs = rxSync1.match(line)
	if rs:
		if state != 1:
			print('ASSERTION FAILURE: {} != s1 (rxSync1)'.format(state))
		if fd != rs.group(1):
			print('ASSERTION FAILURE: fd{} != {}'.format(fd, rs.group(1)))
		state = 2
		continue
	
	rs = rxSync2.match(line)
	if rs:
		if state != 2:
			print('ASSERTION FAILURE: {} != s2 (rxSync2)'.format(state))
		if fd != rs.group(1):
			print('ASSERTION FAILURE: fd{} != {}'.format(fd, rs.group(1)))
		state = 3
		continue
	
	rs = rxHeaderEnd.match(line)
	if rs:
		if state != 5:
			print('ASSERTION FAILURE: {} != s5 (rxHeaderEnd)'.format(state))
		if fd != rs.group(1):
			print('ASSERTION FAILURE: fd{} != {}'.format(fd, rs.group(1)))
		state = 6
		continue
	
	# this needs to be checked after rxHeaderEnd due to similar pattern
	rs = rxHeaderStart.match(line)
	if rs:
		if state != 3:
			print('ASSERTION FAILURE: {} != s3 (rxHeaderStart)'.format(state))
		if fd != rs.group(1):
			print('ASSERTION FAILURE: fd{} != {}'.format(fd, rs.group(1)))
		state = 4
		continue
	
	rs = rxBodyStart.match(line)
	if rs:
		if state != 6:
			print('ASSERTION FAILURE: {} != s6 (rxBodyStart)'.format(state))
		if fd != rs.group(1):
			print('ASSERTION FAILURE: fd{} != {}'.format(fd, rs.group(1)))
		state = 7
		continue
	
	rs = txBody.match(line)
	if rs:
		if state != 8:
			print('ASSERTION FAILURE: {} != s8 (txBody)'.format(state))
		if fd != rs.group(1):
			print('ASSERTION FAILURE: fd{} != {}'.format(fd, rs.group(1)))
		state = 0
		hexstr = rs.group(2)
		lenone = rs.group(3)
		lentwo = rs.group(4)
		if lenone != lentwo:
			print('FRAGMENTED MESSAGE  (NOT IMPLEMENTED)')
			continue
		d = binascii.unhexlify(hexstr.replace('\\x',''))
		dl = 0x100 * ord(d[0]) + ord(d[1])
		d = d[4:4+dl]
		print("\033[0mServer Respose, {} bytes ({}):\n\033[1;35m[\033[0;32m{}\033[1;35m]\033[0m\n".format(dl, len(d),d))
		continue
	
	rs = rxMessage.match(line)
	if rs:
		if state != 4 and state != 7:
			print('ASSERTION FAILURE: {} != s4/s7 (rxMessage)'.format(state))
			continue
		if fd != rs.group(1):
			print('ASSERTION FAILURE: fd{} != {}'.format(fd, rs.group(1)))
			continue
		state += 1
		
		if state == 8:
			hexstr = rs.group(2)
			d = binascii.unhexlify(hexstr.replace('\\x',''))
			print("\033[0mHTTP Body from Client, {} byte:\n\033[1;35m[\033[1;33m{}\033[1;35m]\033[0m\n".format(len(d),d))
			continue
			
		if state == 5:
			hexstr = rs.group(2)
			lenone = rs.group(3)
			lentwo = rs.group(4)
			if lenone != lentwo:
				print('FRAGMENTED MESSAGE  (NOT IMPLEMENTED)')
				continue
			if lenone < 64:
				continue
			
			d = binascii.unhexlify(hexstr.replace('\\x',''))
			if 'SCRIPT_FILENAME' not in d or 'GATEWAY_INTERFACE' not in d:
				print('(probably not an fcgi message)')
				continue
			
			a = 0
			n = len(d)
			while a < n:
				
				# byte <  0x80:  length, this byte only
				# byte >= 0x80:  length, this-0x80 + 3 next bytes, msb first
				
				l1 = ord(d[a])
				if l1 >= 0x80:
					l1 -= 0x80
					l1 *= 0x100
					l1 += ord(d[a+1])
					l1 *= 0x100
					l1 += ord(d[a+2])
					l1 *= 0x100
					l1 += ord(d[a+3])
					a += 3
				a += 1
				
				l2 = ord(d[a])
				if l2 >= 0x80:
					l2 -= 0x80
					l2 *= 0x100
					l2 += ord(d[a+1])
					l2 *= 0x100
					l2 += ord(d[a+2])
					l2 *= 0x100
					l2 += ord(d[a+3])
					a += 3
				a += 1
				
				v1 = d[a:a+l1].decode('utf-8')
				a += l1
				
				v2 = d[a:a+l2].decode('utf-8')
				a += l2
				
				color = '0;33'
				if v1 in known:
					color = '1;36'
				
				print(('{0:>48}\033[1;35m]\033[1;30m{2:>3}\033[1;35m,\033[1;30m{3:<4}' +
					'\033[1;35m[\033[1;33m{1}\033[1;35m]\033[0m').format(
					'\033[1;35m[\033[' + color + 'm' + v1,
					v2, l1, l2))
			print("\033[0m")
